#ifndef __POINTER_H__
#define __POINTER_H__

#include "library.h"
#include "object.h"

typedef
struct _pointer_t {
	object_t parent;
	void	*data;
	delete_t pdelete;
} pointer_t;

typedef
struct _pointer_class_t {
	object_class_t	 parent;
} pointer_class_t;

void		*pointer_get(pointer_t *p);
void		 pointer_set(pointer_t *p, void *data);
void		 pointer_set_destructor(pointer_t *p, delete_t func);
pointer_t	*pointer_new_Pv(void *data);
pointer_t	*pointer_new_PvP8delete_t(void *data, delete_t func);

#endif
