#ifndef __REGEXLIST_H__
#define __REGEXLIST_H__

#include "library.h"
#include "wregex.h"
#include "list.h"

#if 0	/* This definition can stay private in the C file */
typedef
struct _regexlist_data_t {
	char		*regex;
	wregex_t	*preg;
	bool		 match;
} regexlist_data_t;
#endif

typedef
struct _regexlist_t {
	list_t			*list;
	list_iterator_t	*iter;
} regexlist_t;

regexlist_t	*regexlist_new(void);
void		 regexlist_delete(regexlist_t *r);
bool		 regexlist_push_back(regexlist_t *r,
								char *regex,bool invert);
bool		 regexlist_execute(regexlist_t *r, char *str);

#endif
