#ifndef __INTEGER_H__
#define __INTEGER_H__

#include "object.h"

typedef
struct _integer_t {
	object_t parent;
	int		 i_value;
} integer_t;

typedef
struct _integer_class_t {
	object_class_t	 parent;
} integer_class_t;

#define integerp(i) (object_typenum(OBJ(i)) == integer_type())

int			 integer_type(void);
int			 integer_get(integer_t *i);
void		 integer_set(integer_t *i, int val);
integer_t	*integer_new_i(int val);

#endif
