#ifndef __MUDMODE_H__
#define __MUDMODE_H__

#include "object.h"

/* This could be interesting. */
#define MM_NONE		(1<<0)	/* 1		*/
#define MM_ARRAY	(1<<1)	/* 2		*/
#define MM_EARRAY	(1<<2)	/* 4		*/
#define MM_STRING	(1<<3)	/* 8		*/
#define MM_VALUE	(1<<4)	/* 16		*/
#define MM_MAPPING	(1<<5)	/* 32		*/
#define MM_EMAPPING	(1<<6)	/* 64		*/
#define MM_MAPDATA	(1<<7)	/* 128		*/
#define MM_COMMA	(1<<11)	/* 2048		*/
#define MM_COLON	(1<<12)	/* 4096		*/
#define MM_EOL		(1<<13)	/* 8192		*/
#define MM_EOF		(1<<14)	/* 16384	*/
#define MM_ERR		(1<<15)	/* 32768	*/

object_t	*parse_buffer(char *buffer);

#endif
